/*
voice_recogn_8x32 dot matrix
아래 링크에서 LedControl 라이브러리를 다운로드
https://github.com/wayoda/LedControl

www.mcuboard.com
*/


#include "LedControl.h" // 라이브러리 사용 선언
#include <SoftwareSerial.h> // 소프트웨어 Serial 통신을 하기 위해 라이브러리 사용

// Serial 통신핀으로 D11번핀을 Rx로, D10번핀을 Tx로 선언
SoftwareSerial mySerial(2, 3); // 모듈 TX=11번핀 , RX=10번핀 연결

// Din 핀을 12번, ClK핀을 11번 CS핀을 10번에 연결, 매트릭스는 1개를 사용 선언
LedControl lc=LedControl(12,11,10,1);
int voice_recogn=0;

byte data[5][8]=
{
    // 무표정 이미지
             {
             B11111111,
             B10000001,
             B10100101,
             B10000001,
             B10000001,
             B10111101,
             B10000001,
             B11111111
             },
  // 웃는 표정 이미지
             {
             B11111111,
             B10000001,
             B10100101,
             B10000001,
             B10100101,
             B10111101,
             B10000001,
             B11111111
             },
  // 십자가 모양
             { 
             B00011000,
             B00011000,
             B00011000,
             B11111111,
             B11111111,
             B00011000,
             B00011000,
             B00011000
             },
  // 하트 모양
             {
             B00000000,
             B01100110,
             B11111111,
             B11111111,
             B11111111,
             B01111110,
             B00111100,
             B00011000
             },
  // 동그란 웃는모양             
             {
             B00111100,
             B01000010,
             B10100101,
             B10000001,
             B10100101,
             B10011001,
             B01000010,
             B00111100
             }
};

void setup()
{
   Serial.begin(9600); // 통신 속도 9600bps로 PC와 시리얼 통신 시작
   mySerial.begin(9600); // 통신 속도 9600bps로 모듈과 시리얼 통신 시작
   lc.shutdown(0,false); // 0~3번까지 매트릭스 절전모드 해제
   lc.setIntensity(0,8); // 매트릭스의 밝기 선언 0~15의 수
   lc.clearDisplay(0); // 매트릭스 led를 초기화
 
   Serial.println("wait settings are in progress");
   delay(1000);
   mySerial.write(0xAA); // compact mode 사용 
   mySerial.write(0x37); 
   delay(1000);
   mySerial.write(0xAA); // 그룹1 음성 명령어 imported
   mySerial.write(0x21);
    
   Serial.println("The settings are complete");
}

void loop() 
{
  while(mySerial.available()) 
  {
    Serial.println("voice input");
    voice_recogn=mySerial.read();

    switch(voice_recogn) 
    {
      case 0x11:
      for(int j=0; j<8; j++)
       {
        lc.setRow(0,j,data[0][j]); // 무표정 이미지 출력
       }
      Serial.println("무표정 이미지 출력");

       break;
       
      case 0x12:
      for(int j=0; j<8; j++)
       {
        lc.setRow(0,j,data[1][j]); // 웃는 표정 이미지 출력
       }
       Serial.println("웃는 표정 이미지 출력");

       break;

      case 0x13:
      for(int j=0; j<8; j++)
       {
        lc.setRow(0,j,data[2][j]); // 십자가 모양 이미지 출력
       }
       Serial.println("십자가 모양 이미지 출력");

       break;
       
      case 0x14:
      for(int j=0; j<8; j++)
       {
        lc.setRow(0,j,data[3][j]); // 하트 모양 이미지 출력
       }
       Serial.println("하트 모양 이미지 출력");

       break;  
            
      case 0x15:
      for(int j=0; j<8; j++)
       {
        lc.setRow(0,j,data[4][j]); // 동그란 웃는 표정 이미지출력
       }
       Serial.println("동글 웃는 이미지 출력");

       break;
   }
  }
}
